package com.izouma.jiashanxia.web;

import com.izouma.jiashanxia.domain.GoodsInfo;
import com.izouma.jiashanxia.service.GoodsInfoService;
import com.izouma.jiashanxia.dto.PageQuery;
import com.izouma.jiashanxia.exception.BusinessException;
import com.izouma.jiashanxia.repo.GoodsInfoRepo;
import com.izouma.jiashanxia.utils.ObjUtils;
import com.izouma.jiashanxia.utils.excel.ExcelUtils;
import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/goodsInfo")
@AllArgsConstructor
public class GoodsInfoController extends BaseController {
    private GoodsInfoService goodsInfoService;
    private GoodsInfoRepo    goodsInfoRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public GoodsInfo save(@RequestBody GoodsInfo record) {
        if (record.getId() != null) {
            GoodsInfo orig = goodsInfoRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return goodsInfoRepo.save(orig);
        }
        return goodsInfoRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<GoodsInfo> all(@RequestBody PageQuery pageQuery) {
        return goodsInfoService.all(pageQuery);
    }

    @PostMapping("/allList")
    public List<GoodsInfo> allList() {
        return goodsInfoRepo.findAll();
    }

    @GetMapping("/get/{id}")
    public GoodsInfo get(@PathVariable Long id) {
        return goodsInfoRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        goodsInfoRepo.softDelete(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<GoodsInfo> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

